# coding: utf-8
# email: khahux@163.com

import json
import sys

import getopt
from urllib import quote
import urllib2

from termcolor import colored


KEYFROM = 'khahux'
KEY = '1132608537'
DOCTYPE = 'json'

URL = 'http://fanyi.youdao.com/openapi.do?keyfrom={keyform}&key={key}&type=data&doctype={doctype}&version=1.1&q='


def get_res(keyword):
    url = URL.format(keyform=KEYFROM, key=KEY, doctype=DOCTYPE) + quote(keyword)
    return urllib2.urlopen(url).read()


def show_terminal(res):
    read_res = json.loads(res)
    if read_res['errorCode'] == 20:
        print colored('要翻译的文本过长', 'red')
    elif read_res['errorCode'] == 30:
        print colored('无法进行有效的翻译', 'red')
    elif read_res['errorCode'] == 40:
        print colored('不支持的语言类型', 'red')
    elif read_res['errorCode'] == 50:
        print colored('无效的key', 'green')
    elif read_res['errorCode'] == 60:
        print colored('无词典结果', 'green')
    elif read_res['errorCode'] == 0:
        try:
            print '----------------------'
            print '| ' + colored('translation:', 'yellow') + colored(read_res['translation'][0], 'green')
            print '----------------------'
            print '| ' + colored('--phonetic-:', 'yellow') + colored(read_res['basic']['phonetic'], 'green')
            print '----------------------'
        except:
            print '----------------------'
    else:
        print '呵呵,我也不知咋回事!'


def main():
    try:
        options, args = getopt.getopt(sys.argv[1:], ["help"])
    except getopt.GetoptError:
        pass

    keyword = " ".join(args).lower()
    res = get_res(keyword)
    show_terminal(res)


if __name__ == '__main__':
    main()